<?php
/**
 * JsonController takes care of json related actions for the companies module.
 * 
 * @package dotproject3
 * @subpackage Companies
 * @author ebrosnan
 */
require_once 'Zend/Controller/Action.php';

class Companies_JsonController extends Zend_Controller_Action {
	/**
	 * JSON Projects Index
	 */
	public function indexAction() {
		
		$sort = $this->getRequest()->getParam('sort');
		
		$tbl_companies = new Companies_Model_DbTable_Companies();
		$fields = array(
			'id'=>'company_id', 
			'name'=>'company_name', 
			'type'=>'company_type');
		
		$order_by = array();
		
		if (!empty($sort)) {
			foreach ($sort as $field => $direction) {
				$n_direction = strtolower($direction);
				if ($n_direction == 'asc' || $n_direction == 'desc') {
					$order_by[] = $fields[strtolower($field)] . ' ' . strtoupper($n_direction);
				}
			}
		}
		
		$select = $tbl_companies->select()->from($tbl_companies, $fields)->order($order_by)->limit(30);
		
		$q = $this->getRequest()->getParam('q');
		if (!empty($q)) {
			$select->where("company_name LIKE ?", "%{$q}%");
		}
		
		$result_companies = $tbl_companies->fetchAll($select)->toArray();
		$result = array(
			'resultCount' => count($result_companies),
			'results' => $result_companies
		);
		
		$this->_helper->json($result);
	}


}


