<?php
class Projects_Bootstrap extends Zend_Application_Module_Bootstrap
{
	public function _initReferencedResources()
	{
		// TODO: Find a neater way of loading inter-module dependencies.. maybe some sort of singleton dependency loader.
		// Reason for this - Zend_Application_Module_Resource_Autoloader only loads resources for the CURRENT module
		// If you want inter-module classes you have to go get them yourself.
		
		$al = Zend_Loader_Autoloader::getInstance();
		

		
		$standard_module_resources = array(
            'dbtable' => array(
                'namespace' => 'Model_DbTable',
                'path'      => 'models/DbTable',
            ),
            'mappers' => array(
                'namespace' => 'Model_Mapper',
                'path'      => 'models/mappers',
            ),
            'form'    => array(
                'namespace' => 'Form',
                'path'      => 'forms',
            ),
            'model'   => array(
                'namespace' => 'Model',
                'path'      => 'models',
            ),
            'plugin'  => array(
                'namespace' => 'Plugin',
                'path'      => 'plugins',
            ),
            'service' => array(
                'namespace' => 'Service',
                'path'      => 'services',
            ),
            'viewhelper' => array(
                'namespace' => 'View_Helper',
                'path'      => 'views/helpers',
            ),
            'viewfilter' => array(
                'namespace' => 'View_Filter',
                'path'      => 'views/filters',
            )
        );
		
        // Autoload from Companies Module
       	$companies_ldr = new Zend_Loader_Autoloader_Resource(array(
			'BasePath' => APPLICATION_PATH . '/modules/companies',
			'namespace' => 'Companies'
		));
		$companies_ldr->addResourceTypes($standard_module_resources);
        $companies_ldr->setDefaultResourceType('model');
        $al->unshiftAutoloader($companies_ldr, 'Companies');
		
        // Autoload from Admin Module
        $admin_ldr = new Zend_Loader_Autoloader_Resource(array(
        	'BasePath' => APPLICATION_PATH . '/modules/admin',
			'namespace' => 'Admin'
        ));
 		$admin_ldr->addResourceTypes($standard_module_resources);
        $admin_ldr->setDefaultResourceType('model');
        $al->unshiftAutoloader($admin_ldr, 'Admin');       
	}
}