<?php
/**
 * JsonController takes care of json related actions for projects module.
 * 
 * @package dotproject3
 * @subpackage Projects
 * @author ebrosnan
 */
require_once 'Zend/Controller/Action.php';

class Projects_JsonController extends Zend_Controller_Action {
	/**
	 * JSON Projects Index
	 */
	public function indexAction() {
		
		$sort = $this->getRequest()->getParam('sort');
		
		$tbl_projects = new Projects_Model_DbTable_Projects();
		$fields = array(
			'id'=>'project_id', 
			'name'=>'project_name', 
			'start'=>'project_start_date', 
			'finish'=>'project_end_date',
			'status'=>'project_status',
                        'progress'=>'project_percent_complete');

                $order_by = $this->_helper->sortNormalizer($sort, $fields);
		$select = $tbl_projects->select()->from($tbl_projects, $fields)->order($order_by)->limit(30);
		
		$q = $this->getRequest()->getParam('q');
		if (!empty($q)) {
			$select->where("project_name LIKE ?", "%{$q}%");
		}
                
                $company_id = $this->getRequest()->getParam('company_id');
                if (!empty($company_id)) {
                    $select->where("project_company = ?", $company_id);
                }
		
		$result_projects = $tbl_projects->fetchAll($select)->toArray();
		$result = array(
			'resultCount' => count($result_projects),
			'results' => $result_projects
		);
		
		$this->_helper->json($result);
	}
        
        public function tasksAction() {
 		$sort = $this->getRequest()->getParam('sort');
		$project_id = $this->getRequest()->getParam('project_id');
                
		$tbl_tasks = new Projects_Model_DbTable_Tasks();
		$fields = array(
                    'id'=>'task_id', 
                    'name'=>'task_name', 
                    'start'=>'task_start_date', 
                    'finish'=>'task_end_date',
                    'progress'=>'task_percent_complete');

                $order_by = $this->_helper->sortNormalizer($sort, $fields);
               
		$select = $tbl_tasks->select()->from($tbl_tasks, $fields)->order($order_by)->limit(30);
		$select->where("task_project = ?", $project_id);
                
		$q = $this->getRequest()->getParam('q');
		if (!empty($q)) {
			$select->where("task_name LIKE ?", "%{$q}%");
		}
		
                $project_id = $this->getRequest()->getParam('project_id');
                if (!empty($project_id)) {
                    $select->where("task_project = ?", $company_id);
                }              
                
		$result_projects = $tbl_tasks->fetchAll($select)->toArray();
		$result = array(
			'resultCount' => count($result_projects),
			'results' => $result_projects
		);
		
		$this->_helper->json($result);           
            
        }

}

