<?php

/**
 * Sub-class of DP_List containing Project list specific query information.
 * 
 * TODO: This is really a DP_List class that only has specific information stored within. This would probably be better done
 * with a DP_List that has been augmented, or a factory that pre-configures a DP_List for this specific application.
 * 
 * @author ebrosnan
 * @package dotproject3
 * @subpackage Projects
 */
class Projects_Model_List_Projects extends DP_List
{
	public function __construct()
	{
		parent::__construct();
		
		$this->tbl = new Projects_Model_DbTable_Projects();
		$select = $this->tbl->select();
		$select->setIntegrityCheck(false); // Normally you cannot return columns from another table as this violates the table gateway pattern.
		
		$select->from($this->tbl)
				->join(array('c'=>'companies'),
					'project_company = c.company_id',
					array('company_id', 'company_name'))
				->join(array('u'=>'users'),
					'project_owner = u.user_id'
				);
		
		$this->base_query = $select;

		// TODO: functions required for the pager.
		// Get row count without WHERE clause applied.
		// Set row count to local variable.
	}
}