<?php
/**
 * Dummy authentication adapter which always allows the user to log in, regardless of the details.
 * 
 * This is used primarily with testing. 
 * 
 * @author ebrosnan
 * @package dotproject3
 * @subpackage DP_Auth
 */
class DP_Auth_Adapter_Dummy implements Zend_Auth_Adapter_Interface
{
    /**
     * @var String Username supplied.
     */
    private $username;
    
    /**
     * Dummy auth adapter constructor
     * 
     * @param $username String the username to authenticate.
     */
    public function __construct( $username )
    {
        $this->username = $username;
    }
    
    /**
     * @see Zend_Auth_Adapter_Interface::authenticate()
     */
    public function authenticate()
    {
        return new Zend_Auth_Result(Zend_Auth_Result::SUCCESS, $this->username);
    }
}