<?php
/**
 * YUI Bootstrap resource.
 * 
 * Takes care of settings which determine which yui files to link in the head section.
 * 
 * TODO: needs a much simpler, smaller design.
 * 
 * @package dotproject3
 * @subpackage DP_Bootstrap
 */
class DP_Bootstrap_Resource_Yui extends Zend_Application_Resource_ResourceAbstract 
{
	/**
	 * Default Zend_Registry key to use.
	 * @var DEFAULT_REGISTRY_KEY
	 */
	const DEFAULT_REGISTRY_KEY = 'Yui';
	
	/**
	 * Default Yahoo CDN to use.
	 * @var DEFAULT_CDN_PATH
	 */
	const DEFAULT_CDN_PATH = 'http://yui.yahooapis.com/3.1.1/';
	
	/**
	 * Initialise settings for yui helpers, decide which set of yui build files to use and whether or not to use the Yahoo CDN.
	 */
	public function init()
	{
		$options = $this->getOptions();
		$yui_options = Array();
		
		// Use the Yahoo UI CDN?
		if (isset($options['usecdn']) && true == $options['usecdn']) {
			$yui_options['usecdn'] = true;
		} else {
			$yui_options['usecdn'] = false;
		}
		
		// Suffix to append to .js files, allows you to specify debug or minified builds.
		if (isset($options['suffix'])) {
			$suffix_normal = strtolower($options['suffix']);
			$valid_suffixes = Array('min', 'debug');
			
			if (in_array($suffix_normal, $valid_suffixes)) {
				$yui_options['suffix'] = $suffix_normal;
			}
		}
		
		// Path to use as the base for local YUI3 based scripts. not including build/ or src/
		if (isset($options['localpath'])) {
			$yui_options['localpath'] = $options['localpath'];
		}
		
		// Path to use as the base for CDN based scripts. not including build/ or src/
		if (isset($options['cdnpath'])) {
			$yui_options['cdnpath'] = $options['cdnpath'];
		} else {
			$yui_options['cdnpath'] = self::DEFAULT_CDN_PATH;
		}
		
		// Use build or source version
		if (isset($options['usebuild']) && true == $options['usebuild']) {
			$yui_options['usebuild'] = true;
		} else {
			$yui_options['usebuild'] = false;
		}
		
		Zend_Registry::set(self::DEFAULT_REGISTRY_KEY, $yui_options);
	}	
	
}