<?php
/**
 * Helper which takes care of the common CRUD functionality for update/save.
 * 
 * @package dotproject3
 * @subpackage DP_Controller
 */
class DP_Controller_Action_Helper_SaveObject extends Zend_Controller_Action_Helper_Abstract
{
	public function direct(Zend_Form $form, $id_key)
	{
		$tbl = DP_DbTable::factory($this->getRequest()->getModuleName());
		
		$values = $form->getValues();
		$id = $values[$id_key];
		
		if ($id != '') {
			$where = $tbl->getAdapter()->quoteInto($id_key.' = ?', $id);
			$updated_obj = $tbl->createRow($values);
			$tbl->update($updated_obj->toArray(), $where);
			
			// Set message updated
			$this->getActionController()->getHelper('FlashMessenger')->direct('Object updated.');
		} else {
			$new_obj = $tbl->createRow($values);
			$new_obj->$id_key = null;
			$new_obj->save();
			
			// Set message created
			$this->getActionController()->getHelper('FlashMessenger')->direct('Object saved.');
		}	
	}
}