<?php
/**
 * SortNormalizer reduces a list of sorting keys and directions from GET variables down to
 * an array of sorting rules only containing valid pairs.
 * 
 * @package dotproject3
 * @subpackage system
 * @category ActionHelper
 */
class DP_Controller_Action_Helper_SortNormalizer extends Zend_Controller_Action_Helper_Abstract
{
    /**
     * Normalise a set of sorting rules.
     * 
     * @param Array $sort GET parameters with fields and their sort direction.
     * @param Array $fields Hash map of short field names to database field names
     * @return Array of SQL ORDER BY conditions.
     */
    public function direct($sort, $fields)
    {
        
        $order_by = array();
        
        if (!empty($sort)) {
                foreach ($sort as $field => $direction) {
                        $n_direction = strtolower($direction);
                        if ($n_direction == 'asc' || $n_direction == 'desc') {
                                $order_by[] = $fields[strtolower($field)] . ' ' . strtoupper($n_direction);
                        }
                }
        }
        
        return $order_by;
    }
}