<?php
/**
 * Zend_Db_Table factory.
 *
 * Uses the requested module name to determine the relevant table class to return.
 * 
 * TODO: In future allow modules to add their own types. So this can be used for all installed
 * modules, even the ones outside of the standard set.
 * 
 * @package dotproject3
 * @subpackage DP_DbTable
 */
class DP_DbTable
{
	static public function factory($module)
	{		
		switch($module) {
			case $module == 'projects':
				return new Projects_Model_DbTable_Projects();
				break;
			case $module == 'companies':
				return new Companies_Model_DbTable_Companies();
				break;
			default:
				return null;	
		}
	}
}