<?php
/**
 * Client side validation decorator.
 * 
 * Produces a hidden element which is rendered alongside each visible element, indicating
 * validation rules to the client side.
 * 
 * The client side script will provide visual feedback of incorrect elements.
 * 
 * @package dotproject
 * @subpackage DP
 * @author eb
 */
class DP_Form_Decorator_JsValidate extends Zend_Form_Decorator_Abstract
{

	public function render($content)
	{
		
		$element = $this->getElement();
		$validators = $element->getValidators();
		
		$output = "*";
		
		foreach ($validators as $validator) {
			$output .= get_class($validator);
		}
		
		$separator = $this->getSeparator();
		$placement = $this->getPlacement();
		
        switch ($placement) {
            case (self::PREPEND):
                return $output . $separator . $content;
            case (self::APPEND):
            default:
                return $content . $separator . $output;
        }
	}
	
}