<?php
// To supercede DP_Filter, DP_Query_Sort etc from old codebase.

class DP_Modifier
{
	/**
	 * @var Mixed Identifier. Used to uniquely identify this modifier from others.
	 */
	protected $id;
	
	public function __construct($id = -1)
	{
		$this->id = $id;
	}
	
	/**
	 * Getter for the ID attribute.
	 * @return Mixed Modifier ID.
	 */
	public function id()
	{
		return $this->id;
	}
	
	// Factory method for quick instantiation of modifiers.
	
	public static function factory( $modifier_type, $modifier_id, Array $options = Array() )
	{
		switch ($modifier_type) {
			case 'filter':
				$m = new DP_Modifier_Filter($modifier_id);
				if (isset($options['rules']) && is_array($options['rules'])) {
					foreach ($options['rules'] as $r) {
						$m->addRule( $r['field'], $r['operation'], $r['value'] );
					}
				}

				return $m;
		}
	}
}