<?php
/**
 * View helper which renders a DP_View_Stateful_Columns object into a set of table headings.
 * 
 * This helper should respect the sort rules returned by the columns object when iterating, and display the relevant
 * feedback which indicates which columns are sorted and in what direction they are sorted.
 * 
 * @author ebrosnan
 * @package dotproject3
 * @subpackage DP_View_Helper
 */

class DP_View_Helper_DpViewColumns extends Zend_View_Helper_Abstract
{	
		
	public function dpViewColumns( DP_View_Stateful_Columns $cols )
	{
		$html = '';
		$tab = 0;
		
		$html .= "<tr>\n";
		
		foreach ($cols as $field => $definition)
		{	
			$title = isset($definition['title']) ? $definition['title'] : $field;
			$sort_direction = isset($definition['sort']) ? $definition['sort'] : null;
			
			$html .= '<th>';
			$html .= '<a href="?view_id='.$cols->id().'&sort='.$field.'">';
			$html .= $title;
			
			switch($sort_direction) {
				case DP_Modifier_Sort::SORT_ASCENDING:
					$html .= '&nbsp;(ASC)';
					break;
				case DP_Modifier_Sort::SORT_DESCENDING:
					$html .= '&nbsp;(DESC)';
					break;
				default:
					// No sort indicator
			}
			
			$html .= "</a></th>\n";
		}
		
		$html .= "</tr>\n";
		return $html;
	}
}