<?php

/**
 * View helper used to render DP_View_Stateful_List objects
 * @author ebrosnan
 * @package dotproject3
 * @subpackage DP_View_Helper
 */
class DP_View_Helper_DpViewList extends Zend_View_Helper_Abstract
{
	/**
	 * @var $_column_helper Name of the view helper that will be used to render the table column headings.
	 */
	protected $_column_helper = 'dpViewColumns';
	
	public function dpViewList( DP_View_Stateful_List $list_view = null )
	{
		$columns = $list_view->getColumns();
		$data = $list_view->getDataSource();
		
		$html = '<table id="' . $list_view->id() . '" class="dp-view-list">';
		
		// No columns: then just omit headings
		if ($columns instanceof DP_View_Stateful_Columns) {
			$column_markup = $this->view->{$this->_column_helper}( $columns );
			$html .= $column_markup;
		}
		
		if ($data->count() > 0) {
			try {
				$html .= $this->view->partialLoop('list_row.phtml', $data);
			} catch (Exception $e) {
				$html .= 'Exception: ' . $e->getMessage();
			}
		} else {
			$html .= '<tr><td colspan="' . $columns->count() . '">There are no items that match your search criteria.</td></tr>';
		}
		
		$html .= '</table>';
		
		return $html;
	}
}