<?php

/**
 * View helper renders the state of a DP_View_Stateful_SelectFilter object.
 * 
 * @author ebrosnan
 * @package dotproject3
 * @subpackage DP_View_Helper
 */
class DP_View_Helper_DpViewSelectFilter extends Zend_View_Helper_Abstract
{
	/**
	 * Render a SelectFilter Widget.
	 * 
	 * @param DP_View_Stateful_SelectFilter $select_filter The instance to render, usually supplied by the instances own render() method.
	 * @return HTML Markup
	 */
	public function dpViewSelectFilter( DP_View_Stateful_SelectFilter $select_filter )
	{
		//Zend_Debug::dump($select_filter->getSelectedValue());
		
		$html = '<form id="' . $select_filter->id() . '-form" method="GET" action="">';
		$html .= '<input type="hidden" name="view_id" value="' . $select_filter->id() . '" />';
		$html .= '<select name="select" onChange="this.form.submit();">';
		
		if ($select_filter->getInsertBlankItem()) {
			$html .= '<option value=""';
			
			if ($select_filter->getSelectedValue() === null) {
				$html .= ' selected';
			}
			
			$html .= '></option>';
		}
		
		foreach($select_filter as $i => $s) {
			//Zend_Debug::dump($s);
			$html .= '<option value="' . $s['value'] . '"';
			if ($s['value'] == $select_filter->getSelectedValue()) {
				$html .= ' selected';
			}
			$html .= '>' . $s['title'] .'</option>'; 
		}
		
		$html .= '</select></form>';
		
		return $html;
	}
	
}