<?php

/**
 * DP Tab View
 * 
 * @author ebrosnan
 * @package dotproject3
 * @subpackage DP_View_Helper
 */
class DP_View_Helper_DpViewTabs extends Zend_View_Helper_Abstract
{
	/**
	 * Render a DP_View_Stateful_Tabs Control.
	 * 
	 * Iterates through the tabs and produces the html output necessary for a tab control.
	 * 
	 * @param DP_View_Stateful_Tabs $tabs
	 */
	public function dpViewTabs( DP_View_Stateful_Tabs $tabs )
	{
		
		$html = '<ul class="dp-view-stateful-tabs" id="' . $tabs->id() . '">';
		//$html .= $tabs->selectedIndex();
		
		//$html .= '<li class="tab_left_edge"></li>';
		
		foreach ($tabs as $k => $t) {
			$title = $t['title'];
			
			$html .= '<li ';
			
			if ($tabs->isTabSelected($k)) {
				$html .= ' class="tab_active"';
			} else {
				$html .= ' class="tab"';
			}
			
			$html .= '>';
			
			// TODO: escape tab id
			$html .= '<a href="?view_id=' . $tabs->id() . '&tab=' . $k . '">';
			$html .= $title . '</a></li>';
		}
		
		//$html .= '<li class="tab_right_edge"></li>';
		
		$html .= '</ul>';
		
		return $html;
	}	
}