<?php

/**
 * Generate a URI for a YUI module based on application configuration.
 * 
 * TODO: needs a much simpler, smaller design.
 * 
 * @package dotproject3
 * @subpackage DP_View_Helper
 */
class DP_View_Helper_Yui extends Zend_View_Helper_Abstract
{
	/**
	 * Generate the base directory for the requested module.
	 * 
	 * @param Array $options options supplied from application config.
	 * @param Boolean $is_local Whether the resource is a local only resource or not.
	 * @return String
	 * @access protected
	 */
	protected function _yuiBasePath($options, $is_local) {
		if (true == $is_local) {
			return $options['localpath'];
		} else {
			return (true == $options['usecdn']) ? $options['cdnpath'] : $options['localpath'];
		}
	}
	
	/**
	 * Generate the module directory path for the requested module.
	 * 
	 * @param Array $options options supplied from application config.
	 * @param String $module module name
	 * @return String
	 */
	protected function _yuiModulePath($options, $module) {
		$mod_path = (true == $options['usebuild']) ? '/build' : '/src';
		
		// Folder and file prefix
		$mod_path .= '/' . $module . '/' . $module;

		$mod_path .= (isset($options['suffix'])) ? '-'.$options['suffix'] : '';		
		$mod_path .= '.js';		
		
		return $mod_path;
	}
	
	/**
	 * Get path to YUI module
	 * 
	 * @param String $module Name of the module [default] yui
	 * @return String
	 */
	public function yui($module = 'yui') {
		$options = Zend_Registry::get('Yui');
		
		$js_path = $this->_yuiBasePath($options, false) . $this->_yuiModulePath($options, $module);
		return $js_path;
	}
	
	/**
	 * Get path to locally stored YUI module
	 *
	 * @param String $module Name of the module [default] yui
	 * @return String
	 */
	public function yuiLocal($module = '') {
		$options = Zend_Registry::get('Yui');
		
		$js_path = $this->_yuiBasePath($options, true) . $this->_yuiModulePath($options, $module);
		return $js_path;	
	}
}