<?php

// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH', realpath(dirname(__FILE__) . '/../application'));

// Define application environment
defined('APPLICATION_ENV')
    || define('APPLICATION_ENV', (getenv('APPLICATION_ENV') ? getenv('APPLICATION_ENV') : 'production'));

// Ensure library/ is on include_path
set_include_path(implode(PATH_SEPARATOR, array(
    realpath(APPLICATION_PATH . '/../library'),
    get_include_path(),
)));


/** Zend_Application */
//require_once 'Zend/Application.php';  
// Require will halt execution, preventing the redirect to installer, therefore we use include_once
@include_once 'Zend/Application.php';

if (!class_exists('Zend_Application')) {
	$public_uri = $_SERVER['REQUEST_URI'];
	header('Location: '.$public_uri.'installer/index.php');
} else {

	// Create application, bootstrap, and run
	$application = new Zend_Application(
	    APPLICATION_ENV, 
	    APPLICATION_PATH . '/configs/application.ini'
	);
	$application->bootstrap()
	            ->run();           
}