// Drag n Drop TreeView widget
YAHOO.namespace("DP");

YAHOO.DP.DDTreeView = function(id, oConfig) {
	YAHOO.DP.DDTreeView.superclass.constructor.call(this,id,oConfig);
	
	this.selectionChangedEvent = new YAHOO.util.CustomEvent("selectionChanged", this);
	
	this.subscribe("expand", function(node) {
		console.log('expanded');
		this.selectionChangedEvent.fire(node);
	});
};

YAHOO.lang.extend(YAHOO.DP.DDTreeView, YAHOO.widget.TreeView, {
	
	loadXHRChildren : function(node, onCompleteCallback) {
		console.log('loading children');
		var dsXHR = new YAHOO.util.XHRDataSource("/orgunit/json/children", {responseType : YAHOO.util.DataSource.TYPE_JSON});
		dsXHR.responseSchema = {
				resultsList: "results",
				fields: [{ key: "id" }, { key: "name" }, { key: "description" }],
				metaFields: {
					totalRecords: "totalRecords"
				}
		};
		
		var oCallback = {
			success : function(oRequest, oParsedResponse, oPayload) {
			
				if (YAHOO.lang.isArray(oParsedResponse.results)) {
					 for (var i=0; i < oParsedResponse.results.length; i++) {
						var tempNode = new YAHOO.widget.TextNode({ label : oParsedResponse.results[i].name,
								description : oParsedResponse.results[i].description,
								dbid : oParsedResponse.results[i].id
							}, node, false); 
					 }
				}
				
				onCompleteCallback();
			}
		};
		
		dsXHR.sendRequest("?parent=" + node.data.dbid, oCallback);
		
	}
	
});

// Droppable Text Node

YAHOO.DP.DDTextNode = function(oData, oParent, expanded) {
	YAHOO.DP.DDTextNode.superclass.constructor.call(this,oData,oParent,expanded);
};

YAHOO.lang.extend(YAHOO.DP.DDTextNode, YAHOO.widget.TextNode, {
	oDDTarget: null, // our DDTarget instance
	
	/**
     * Load complete is the callback function we pass to the data provider
     * in dynamic load situations.
     * 
     * Overridden from Widget.Node to add drop target functionality.
     * 
     * Only applies to expanded nodes??
     * @method loadComplete
     */
    loadComplete: function() {
        this.getChildrenEl().innerHTML = this.completeRender();
        this.dynamicLoadComplete = true;
        this.isLoading = false;
        this.expand(true);
        this.tree.locked = false;
        
        //this.oDDTarget = new YAHOO.util.DDTarget(this.getEl());

    },
    
    /**
     * Called when we know we have all the child data.
     * @method completeRender
     * @return {string} children html
     */
    completeRender: function() {
        var sb = [];

        for (var i=0; i < this.children.length; ++i) {
            // this.children[i].childrenRendered = false;
            sb[sb.length] = this.children[i].getHtml();
            this.oDDTarget = new YAHOO.util.DDTarget(this.children[i].getEl());
        }
        
        this.childrenRendered = true;

        return sb.join("");
    }
});