<?php

// These are required, because the autoloader doesn't kick in until the test has been dispatched.
require_once 'Zend/Test/PHPUnit/ControllerTestCase.php';
require_once 'Zend/Application.php';

class Default_IndexControllerTest extends Zend_Test_PHPUnit_ControllerTestCase
{
	// @todo - move to a bootstrap class
    public function setUp()
    {   
    	// Define path to application directory
		defined('APPLICATION_PATH') || define('APPLICATION_PATH', realpath(dirname(__FILE__) . '../../../../../application'));
    
    	$this->bootstrap = new Zend_Application('testing',
            APPLICATION_PATH . '/configs/application.ini');
            
        parent::setUp();
    }
    
    public function testRedirectionWithoutIdentity()
    {
        $this->dispatch('/home');
        //$this->assertRedirectTo('/default/index', 'Redirection to login page if not authenticated.');
        $this->assertModule('default', 'Assert redirection to login');
        $this->assertController('index');
        $this->assertAction('index');
    }
    
    public function testIndexAction()
    {
        $this->dispatch('/');
        $this->assertModule('default', 'Assert document root is default module');
        $this->assertController('index');
        $this->assertAction('index');
    }
    

    
    public function testAdminCanLogin()
    {
        $this->request->setMethod('POST')
                      ->setPost(array(
                          'login' => 'login',
                          'username' => 'admin',
                          'password' => 'passwd'
                      ));
        
        $this->dispatch('/');
        $this->assertRedirectTo('/home', 'Redirection to home module');
    }
    
    public function testInvalidAction()
    {
    	$this->dispatch('/home/INVALIDACTION');
    	
    }
}

